package com.huimv.eartag2.admin.controller;

import com.huimv.eartag2.admin.entity.AppEncrypted;
import com.huimv.eartag2.admin.service.IAppEncryptedService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.scheduling.annotation.Scheduled;
import org.springframework.stereotype.Component;

import javax.crypto.KeyGenerator;
import javax.crypto.SecretKey;

@Component
public class YourApplication {
    @Autowired
    private IAppEncryptedService appEncryptedService;

//    @Scheduled(cron = "0 0 * * * ?")
    private   void getMac() throws Exception {
        String macAddress = MacAddressExample.getMACAddress();
        String diskAddress = MacAddressExample.getDiskId();
//        System.out.println("macAddress= "+macAddress);
//        System.out.println("diskAddress= "+diskAddress);
        if (macAddress != null) {
            SecretKey secretKey = generateAESKey(); // 生成AES密钥
            String encryptedMAC = EncryptionExample.encrypt(macAddress, secretKey);
            String encryptedDisk = EncryptionExample.encrypt(diskAddress, secretKey);

            // 将拼接并加密后的数据传输到服务器，可以使用HTTP POST等方法
            Integer result =  SendMacAddressToServer.sendMacAddress(encryptedMAC+"@hm",encryptedDisk);
            System.out.println(result);
            if (1==result){
//
//                System.out.println("验证失败");
                AppEncrypted appEncrypted = new AppEncrypted();
                appEncrypted.setId(1);
                appEncrypted.setAppEncrypted(result);
                appEncryptedService.updateById(appEncrypted);
                System.exit(0);
            }else {
                AppEncrypted appEncrypted = new AppEncrypted();
                appEncrypted.setId(1);
                appEncrypted.setAppEncrypted(result);
                appEncryptedService.updateById(appEncrypted);
            }


        } else {
            System.out.println("Unable to obtain MAC address. Stopping application.");
            //暂时不停止
//            System.exit(0);
        }

        // Rest of your application logic here
    }
    public static SecretKey generateAESKey() throws Exception {
        KeyGenerator keyGenerator = KeyGenerator.getInstance("AES");
        keyGenerator.init(128); // 128-bit key size
        return keyGenerator.generateKey();
    }

}
